﻿using System.Collections.Generic;
using Phoenix.Xna.Framework.Serialization;

namespace Phoenix.Xna.Framework.Input.Binding
{
    /// <summary>
    /// An InputBinding that contains a list of values such as Keys or Buttons to map.
    /// </summary>
    /// <typeparam name="T">The System.Type contained in the Value list.</typeparam>
    public class CompositeInputBinding<T> : InputBinding
    {
        /// <summary>
        /// Gets or sets the list of bindable input values.
        /// </summary>
        [SerializableIList]
        public List<T> Value { get; set; }
    }
}
