﻿namespace Phoenix.Xna.Framework.Serialization.Markup
{
    /// <summary>
    /// String IDs used by the serializer.
    /// </summary>
    public static class AttributeIDs
    {
        public const string ReferenceStart = "{Reference ";                 // The start of the reference info string.
        public const string ReferenceEnd = "}";                             // The end of the reference info string.
        public const string ReferenceXMLName = "Reference";                 // The reference attribute name.
        public const string ElementXMLName = "Element";                     // The element attribute name.
        public const string FieldIDAttribute = "FieldID";                   // The field ID attribute name.
        public const string PropertyIDAttribute = "PropertyID";             // The property ID attribute name.
        public const string ReferenceIDAttribute = "ReferenceID";           // The reference ID attribute name.
        public const string IsFieldAttribute = "IsField";                   // The is field attribute name.
        public const string IsAssignableAttribute = "IsAssignable";         // The is assignable attribute.
        public const string IsCollectionItemAttribute = "IsCollectionItem"; // The is collection item attribute name.
        public const string IsDictionaryKeyAttribute = "IsDictionaryKey";   // The is dictionary key attribute name.
        public const string IsKeyValuePairAttribute = "IsKeyValuePair";     // The is key value pair attribute name.
        public const string IsGenericType = "IsGenericType";                // The is generic type attribute name.
        public const string KeyValuePairName = "KeyValuePair";              // The key value pair name.
    }
}
